-- Adminer 4.7.8 MySQL dump

SET NAMES utf8;
SET time_zone = '+00:00';
SET foreign_key_checks = 0;
SET sql_mode = 'NO_AUTO_VALUE_ON_ZERO';

SET NAMES utf8mb4;

DROP TABLE IF EXISTS `forum`;
CREATE TABLE `forum` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(50) NOT NULL,
  `password` char(100) NOT NULL,
  `pw_hash` text NOT NULL,
  `pw_encrypted` text NOT NULL,
  `pw_hash_encrypted` text NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `username` (`username`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `forum` (`id`, `username`, `password`, `pw_hash`, `pw_encrypted`, `pw_hash_encrypted`) VALUES
(1,	'Harald',	'Wachtwoord',	'',	'',	'');

DROP TABLE IF EXISTS `forum_user`;
CREATE TABLE `forum_user` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `forum_account` char(8) NOT NULL,
  `forum_key` varchar(20) NOT NULL,
  `forum_password` text DEFAULT NULL,
  PRIMARY KEY (`forum_account`),
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

DROP TABLE IF EXISTS `forum_user_info`;
CREATE TABLE `forum_user_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `forum_user_account` char(8) NOT NULL,
  `forum_user_namef` char(50) NOT NULL,
  `forum_user_namel` char(50) NOT NULL,
  PRIMARY KEY (`forum_user_account`),
  UNIQUE KEY `id` (`id`),
  KEY `forum_user_namel` (`forum_user_namel`),
  CONSTRAINT `forum_user_info_ibfk_3` FOREIGN KEY (`forum_user_account`) REFERENCES `forum_user` (`forum_account`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

DELIMITER ;;

DROP PROCEDURE IF EXISTS `delete_10`;;
CREATE PROCEDURE `delete_10`()
DELETE FROM `forum_user`
WHERE
	`id` NOT IN (
		SELECT * FROM (
			SELECT `id`
			FROM `forum_user`
			ORDER BY `id` DESC
			LIMIT 10) s
		);;

DROP PROCEDURE IF EXISTS `forum_user_insert`;;
CREATE PROCEDURE `forum_user_insert`(IN `faccount` char(8), IN `fhash` char(60), IN `fnamef` char(60), IN `fnamel` char(60))
BEGIN
DECLARE enckey CHAR(15);
SET enckey = CONCAT(
    LPAD(CONV(FLOOR(RAND()*POW(36,8)), 10, 36), 5, 0),
    LPAD(CONV(FLOOR(RAND()*POW(36,8)), 10, 36), 5, 0),
    LPAD(CONV(FLOOR(RAND()*POW(36,8)), 10, 36), 5, 0)
);

INSERT INTO
forum_user ( forum_account, forum_key, forum_password )
VALUES ( faccount, enckey, HEX( AES_ENCRYPT( fhash, enckey ) ) );

INSERT INTO forum_user_info ( forum_user_account, forum_user_namef, forum_user_namel )
VALUES ( faccount, fnamef, fnamel );
END;;

DELIMITER ;

DROP VIEW IF EXISTS `forum_show_users`;
CREATE VIEW `forum_show_users` AS select `fu`.`forum_account` AS `forum_account`,concat(`fui`.`forum_user_namel`,', ',`fui`.`forum_user_namef`) AS `forum_name`,`fu`.`forum_key` AS `forum_key`,aes_decrypt(unhex(`fu`.`forum_password`),`fu`.`forum_key`) AS `pw_hash` from (`forum_user` `fu` join `forum_user_info` `fui` on(`fu`.`forum_account` = `fui`.`forum_user_account`)) order by `fui`.`forum_user_namel`;

# doe een call naar de procedure met vooraf gedefinieerde variabelen
# wachtwoord = Super_6484_Liberum
CALL `forum_user_insert`('BE612303', '$2y$10$rsasDBCKJYaozZB02pUJ2uSDpYT0xdSmAuyH/2UJPr8OCYAJk/kDm', 'Super 6484', 'Liberum');

# in PHP

# Accountnummer aanmaken
# je kunt aan de letter de maand en weekdag aflezen.
# $mnum             = substr( '_ABCDEFGHKLMN', date( 'n' ), 1 );
# $dnum             = substr( 'ABCDEFG'      , date( 'w' ), 1 );
# $forum_account    = $mnum . $dnum . random_int ( 100000 , 999999 );

# $forum_account    = 'BE612303'; // februari, donderdag
# $forum_password   = 'Super_6484_Liberum';
# $pw_hash          = password_hash( $forum_password, PASSWORD_BCRYPT );
# $forum_user_namef = 'Super 6484';
# $forum_user_namel = 'Liberum';
# $query = 'CALL forum_user_insert("' . $forum_account . '", "' . $pw_hash . '", "' . $forum_user_namef . '", "' . $forum_user_namel . '");';

# vervolgens toon je alles met

SELECT * FROM forum_user;
SELECT * FROM forum_user_info;
SELECT * FROM forum_show_users;

-- 2021-02-04 11:05:27